Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.rmi.server
Class UnicastRemoteObject

    java.lang.Object
      |
      +--java.rmi.server.RemoteObject
            |
            +--java.rmi.server.RemoteServer
                  |
                  +--java.rmi.server.UnicastRemoteObject

All Implemented Interfaces:
  Remote, Serializable

Direct Known Subclasses:
  ActivationGroup

public class UnicastRemoteObject
extends RemoteServer

The UnicastRemoteObject class defines a non-replicated remote object whose references are valid only while the server process is alive. The UnicastRemoteObject class provides support for point-to-point active object references (invocations, parameters, and results) using TCP streams.

Objects that require remote behavior should extend RemoteObject, typically via UnicastRemoteObject. If UnicastRemoteObject is not extended, the implementation class must then assume the responsibility for the correct semantics of the hashCode, equals, and toString methods inherited from the Object class, so that they behave appropriately for remote objects.

Since:
  JDK1.1
See Also:
  `RemoteServer`, `RemoteObject`, Serialized Form

Fields inherited from class java.rmi.server.RemoteObject
`ref`

Constructor Summary
`protected` | `UnicastRemoteObject()` Create and export a new UnicastRemoteObject object using an anonymous port.
`protected` | `UnicastRemoteObject(int port)` Create and export a new UnicastRemoteObject object using the particular supplied port.
`protected` | `UnicastRemoteObject(int port, RMIClientSocketFactory csf, RMIServerSocketFactory ssf)` Create and export a new UnicastRemoteObject object using the particular supplied port and socket factories.

Method Summary
`Object` | `clone()` Returns a clone of the remote object that is distinct from the original.
`static RemoteStub` | `exportObject(Remote obj)` Export the remote object to make it available to receive incoming calls, using an anonymous port.
`static Remote` | `exportObject(Remote obj, int port)` Export the remote object to make it available to receive incoming calls, using the particular supplied port.
`static Remote` | `exportObject(Remote obj, int port, RMIClientSocketFactory csf, RMIServerSocketFactory ssf)` Export the remote object to make it available to receive incoming calls, using a transport specified by the given socket factory.
`static boolean` | `unexportObject(Remote obj, boolean force)` Remove the remote object, obj, from the RMI runtime.

Methods inherited from class java.rmi.server.RemoteServer
`getClientHost, getLog, setLog`

Methods inherited from class java.rmi.server.RemoteObject
`equals, getRef, hashCode, toString, toStub`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### UnicastRemoteObject

    protected UnicastRemoteObject()
                           throws RemoteException

  Create and export a new UnicastRemoteObject object using an anonymous port.
  Throws:
    `RemoteException` - if failed to export object
  Since:
    JDK1.1

### UnicastRemoteObject

    protected UnicastRemoteObject(int port)
                           throws RemoteException

  Create and export a new UnicastRemoteObject object using the particular supplied port.
  Parameters:
    `port` - the port number on which the remote object receives calls (if `port` is zero, an anonymous port is chosen)
  Throws:
    `RemoteException` - if failed to export object
  Since:
    1.2

### UnicastRemoteObject

    protected UnicastRemoteObject(int port,
                                  RMIClientSocketFactory csf,
                                  RMIServerSocketFactory ssf)
                           throws RemoteException

  Create and export a new UnicastRemoteObject object using the particular supplied port and socket factories.
  Parameters:
    `port` - the port number on which the remote object receives calls (if `port` is zero, an anonymous port is chosen)
    `csf` - the client-side socket factory for making calls to the remote object
    `ssf` - the server-side socket factory for receiving remote calls
  Throws:
    `RemoteException` - if failed to export object
  Since:
    1.2

Method Detail

### clone

    public Object clone()
                 throws CloneNotSupportedException

  Returns a clone of the remote object that is distinct from the original.
  Overrides:
    `clone` in class `Object`
  Returns:
    the new remote object
  Throws:
    `CloneNotSupportedException` - if clone failed due to a RemoteException.
  Since:
    JDK1.1

### exportObject

    public static RemoteStub exportObject(Remote obj)
                                   throws RemoteException

  Export the remote object to make it available to receive incoming calls, using an anonymous port.
  Parameters:
    `obj` - the remote object to be exported
  Returns:
    remote object stub
  Throws:
    `RemoteException` - if export fails
  Since:
    JDK1.1

### exportObject

    public static Remote exportObject(Remote obj,
                                      int port)
                               throws RemoteException

  Export the remote object to make it available to receive incoming calls, using the particular supplied port.
  Parameters:
    `obj` - the remote object to be exported
    `port` - the port to export the object on
  Returns:
    remote object stub
  Throws:
    `RemoteException` - if export fails
  Since:
    1.2

### exportObject

    public static Remote exportObject(Remote obj,
                                      int port,
                                      RMIClientSocketFactory csf,
                                      RMIServerSocketFactory ssf)
                               throws RemoteException

  Export the remote object to make it available to receive incoming calls, using a transport specified by the given socket factory.
  Parameters:
    `obj` - the remote object to be exported
    `port` - the port to export the object on
    `csf` - the client-side socket factory for making calls to the remote object
    `ssf` - the server-side socket factory for receiving remote calls
  Returns:
    remote object stub
  Throws:
    `RemoteException` - if export fails
  Since:
    1.2

### unexportObject

    public static boolean unexportObject(Remote obj,
                                         boolean force)
                                  throws NoSuchObjectException

  Remove the remote object, obj, from the RMI runtime. If successful, the object can no longer accept incoming RMI calls. If the force parameter is true, the object is forcibly unexported even if there are pending calls to the remote object or the remote object still has calls in progress. If the force parameter is false, the object is only unexported if there are no pending or in progress calls to the object.
  Parameters:
    `obj` - the remote object to be unexported
    `force` - if true, unexports the object even if there are pending or in-progress calls; if false, only unexports the object if there are no pending or in-progress calls
  Returns:
    true if operation is successful, false otherwise
  Throws:
    `NoSuchObjectException` - if the remote object is not currently exported
  Since:
    1.2

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.